Index: squid/src/fs/ufs/store_dir_ufs.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/fs/ufs/store_dir_ufs.c,v
retrieving revision 1.1.6.6.2.2
retrieving revision 1.1.6.6.2.3
diff -u -r1.1.6.6.2.2 -r1.1.6.6.2.3
--- squid/src/fs/ufs/store_dir_ufs.c	2 May 2000 22:50:30 -0000	1.1.6.6.2.2
+++ squid/src/fs/ufs/store_dir_ufs.c	14 May 2000 23:22:20 -0000	1.1.6.6.2.3
@@ -71,7 +71,7 @@
 
 static int n_ufs_dirs = 0;
 static int *ufs_dir_index = NULL;
-MemPool * ufs_state_pool = NULL;
+MemPool *ufs_state_pool = NULL;
 static int ufs_initialised = 0;
 
 static char *storeUfsDirSwapSubDir(SwapDir *, int subdirn);
@@ -83,7 +83,7 @@
 static EVH storeUfsDirRebuildFromDirectory;
 static EVH storeUfsDirRebuildFromSwapLog;
 static int storeUfsDirGetNextFile(RebuildState *, int *sfileno, int *size);
-static StoreEntry *storeUfsDirAddDiskRestore(SwapDir *SD, const cache_key * key,
+static StoreEntry *storeUfsDirAddDiskRestore(SwapDir * SD, const cache_key * key,
     int file_number,
     size_t swap_file_sz,
     time_t expires,
@@ -99,9 +99,10 @@
 static STLOGOPEN storeUfsDirOpenSwapLog;
 static STINIT storeUfsDirInit;
 static STFREE storeUfsDirFree;
-static STLOGCLEANOPEN storeUfsDirWriteCleanOpen;
-static void storeUfsDirWriteCleanClose(SwapDir * sd);
+static STLOGCLEANSTART storeUfsDirWriteCleanStart;
+static STLOGCLEANNEXTENTRY storeUfsDirCleanLogNextEntry;
 static STLOGCLEANWRITE storeUfsDirWriteCleanEntry;
+static STLOGCLEANDONE storeUfsDirWriteCleanDone;
 static STLOGCLOSE storeUfsDirCloseSwapLog;
 static STLOGWRITE storeUfsDirSwapLog;
 static STNEWFS storeUfsDirNewfs;
@@ -119,10 +120,6 @@
 static void storeUfsDirStats(SwapDir *, StoreEntry *);
 static void storeUfsDirInitBitmap(SwapDir *);
 static int storeUfsDirValidFileno(SwapDir *, sfileno);
-static int storeUfsDirCheckExpired(SwapDir *, StoreEntry *);
-#if !HEAP_REPLACEMENT
-static time_t storeUfsDirExpiredReferenceAge(SwapDir *);
-#endif
 
 /*
  * These functions were ripped straight out of the heart of store_dir.c.
@@ -132,43 +129,43 @@
  */
 
 int
-storeUfsDirMapBitTest(SwapDir *SD, int fn)
+storeUfsDirMapBitTest(SwapDir * SD, int fn)
 {
     sfileno filn = fn;
     ufsinfo_t *ufsinfo;
-    ufsinfo = (ufsinfo_t *)SD->fsdata;
+    ufsinfo = (ufsinfo_t *) SD->fsdata;
     return file_map_bit_test(ufsinfo->map, filn);
 }
- 
+
 void
-storeUfsDirMapBitSet(SwapDir *SD, int fn)
-{  
+storeUfsDirMapBitSet(SwapDir * SD, int fn)
+{
     sfileno filn = fn;
     ufsinfo_t *ufsinfo;
-    ufsinfo = (ufsinfo_t *)SD->fsdata;
+    ufsinfo = (ufsinfo_t *) SD->fsdata;
     file_map_bit_set(ufsinfo->map, filn);
 }
- 
+
 void
-storeUfsDirMapBitReset(SwapDir *SD, int fn)
-{ 
+storeUfsDirMapBitReset(SwapDir * SD, int fn)
+{
     sfileno filn = fn;
     ufsinfo_t *ufsinfo;
-    ufsinfo = (ufsinfo_t *)SD->fsdata;
+    ufsinfo = (ufsinfo_t *) SD->fsdata;
     file_map_bit_reset(ufsinfo->map, filn);
 }
 
 int
-storeUfsDirMapBitAllocate(SwapDir *SD)
+storeUfsDirMapBitAllocate(SwapDir * SD)
 {
-    ufsinfo_t *ufsinfo = (ufsinfo_t *)SD->fsdata;
+    ufsinfo_t *ufsinfo = (ufsinfo_t *) SD->fsdata;
     int fn;
     fn = file_map_allocate(ufsinfo->map, ufsinfo->suggest);
     file_map_bit_set(ufsinfo->map, fn);
     ufsinfo->suggest = fn + 1;
     return fn;
 }
-    
+
 /*
  * Initialise the ufs bitmap
  *
@@ -176,16 +173,16 @@
  * configured, we allocate a new bitmap and 'grow' the old one into it.
  */
 static void
-storeUfsDirInitBitmap(SwapDir *sd)
+storeUfsDirInitBitmap(SwapDir * sd)
 {
-    ufsinfo_t *ufsinfo = (ufsinfo_t *)sd->fsdata;
+    ufsinfo_t *ufsinfo = (ufsinfo_t *) sd->fsdata;
 
     if (ufsinfo->map == NULL) {
-        /* First time */
+	/* First time */
 	ufsinfo->map = file_map_create();
     } else if (ufsinfo->map->max_n_files) {
-        /* it grew, need to expand */
-        /* XXX We don't need it anymore .. */
+	/* it grew, need to expand */
+	/* XXX We don't need it anymore .. */
     }
     /* else it shrunk, and we leave the old one in place */
 }
@@ -193,7 +190,7 @@
 static char *
 storeUfsDirSwapSubDir(SwapDir * sd, int subdirn)
 {
-    ufsinfo_t *ufsinfo = (ufsinfo_t *)sd->fsdata;
+    ufsinfo_t *ufsinfo = (ufsinfo_t *) sd->fsdata;
 
     LOCAL_ARRAY(char, fullfilename, SQUID_MAXPATHLEN);
     assert(0 <= subdirn && subdirn < ufsinfo->l1);
@@ -246,7 +243,7 @@
 static int
 storeUfsDirVerifyCacheDirs(SwapDir * sd)
 {
-    ufsinfo_t *ufsinfo = (ufsinfo_t *)sd->fsdata;
+    ufsinfo_t *ufsinfo = (ufsinfo_t *) sd->fsdata;
     int j;
     const char *path = sd->path;
 
@@ -263,7 +260,7 @@
 static void
 storeUfsDirCreateSwapSubDirs(SwapDir * sd)
 {
-    ufsinfo_t *ufsinfo = (ufsinfo_t *)sd->fsdata;
+    ufsinfo_t *ufsinfo = (ufsinfo_t *) sd->fsdata;
     int i, k;
     int should_exist;
     LOCAL_ARRAY(char, name, MAXPATHLEN);
@@ -290,12 +287,12 @@
     char *pathtmp2;
     if (Config.Log.swap) {
 	xstrncpy(pathtmp, sd->path, SQUID_MAXPATHLEN - 64);
-	while (index(pathtmp,'/'))
-	    *index(pathtmp,'/')='.';
-	while (strlen(pathtmp) && pathtmp[strlen(pathtmp)-1]=='.')
-	    pathtmp[strlen(pathtmp)-1]= '\0';
-	for(pathtmp2 = pathtmp; *pathtmp2 == '.'; pathtmp2++);
-	snprintf(path, SQUID_MAXPATHLEN-64, Config.Log.swap, pathtmp2);
+	while (index(pathtmp, '/'))
+	    *index(pathtmp, '/') = '.';
+	while (strlen(pathtmp) && pathtmp[strlen(pathtmp) - 1] == '.')
+	    pathtmp[strlen(pathtmp) - 1] = '\0';
+	for (pathtmp2 = pathtmp; *pathtmp2 == '.'; pathtmp2++);
+	snprintf(path, SQUID_MAXPATHLEN - 64, Config.Log.swap, pathtmp2);
 	if (strncmp(path, Config.Log.swap, SQUID_MAXPATHLEN - 64) == 0) {
 	    strcat(path, ".");
 	    snprintf(digit, 32, "%02d", sd->index);
@@ -313,7 +310,7 @@
 static void
 storeUfsDirOpenSwapLog(SwapDir * sd)
 {
-    ufsinfo_t *ufsinfo = (ufsinfo_t *)sd->fsdata;
+    ufsinfo_t *ufsinfo = (ufsinfo_t *) sd->fsdata;
     char *path;
     int fd;
     path = storeUfsDirSwapLogFile(sd, NULL);
@@ -333,7 +330,7 @@
 static void
 storeUfsDirCloseSwapLog(SwapDir * sd)
 {
-    ufsinfo_t *ufsinfo = (ufsinfo_t *)sd->fsdata;
+    ufsinfo_t *ufsinfo = (ufsinfo_t *) sd->fsdata;
     if (ufsinfo->swaplog_fd < 0)	/* not open */
 	return;
     file_close(ufsinfo->swaplog_fd);
@@ -351,9 +348,9 @@
 {
     static int started_clean_event = 0;
     static const char *errmsg =
-    "\tFailed to verify one of the swap directories, Check cache.log\n"
-    "\tfor details.  Run 'squid -z' to create swap directories\n"
-    "\tif needed, or if running Squid for the first time.";
+	"\tFailed to verify one of the swap directories, Check cache.log\n"
+	"\tfor details.  Run 'squid -z' to create swap directories\n"
+	"\tif needed, or if running Squid for the first time.";
     storeUfsDirInitBitmap(sd);
     if (storeUfsDirVerifyCacheDirs(sd) < 0)
 	fatal(errmsg);
@@ -432,7 +429,7 @@
 	tlv_list = storeSwapMetaUnpack(hdr_buf, &swap_hdr_len);
 	if (tlv_list == NULL) {
 	    debug(20, 1) ("storeUfsDirRebuildFromDirectory: failed to get meta data\n");
-            /* XXX shouldn't this be a call to storeUfsUnlink ? */
+	    /* XXX shouldn't this be a call to storeUfsUnlink ? */
 	    storeUfsDirUnlinkFile(SD, sfileno);
 	    continue;
 	}
@@ -552,13 +549,13 @@
 		 * because adding to store_swap_size happens in
 		 * the cleanup procedure.
 		 */
-                storeExpireNow(e);
-                storeReleaseRequest(e);
-                storeUfsDirReplRemove(e);
+		storeExpireNow(e);
+		storeReleaseRequest(e);
+		storeUfsDirReplRemove(e);
 		if (e->swap_filen > -1) {
 		    storeUfsDirMapBitReset(SD, e->swap_filen);
 		    e->swap_filen = -1;
-                    e->swap_dirn = -1;
+		    e->swap_dirn = -1;
 		}
 		storeRelease(e);
 		rb->counts.objcount--;
@@ -603,10 +600,7 @@
 		e->lastmod = s.lastmod;
 		e->flags = s.flags;
 		e->refcount += s.refcount;
-#if HEAP_REPLACEMENT
-		storeHeapPositionUpdate(e, SD);
-                storeUfsDirUnrefObj(SD, e);
-#endif
+		storeUfsDirUnrefObj(SD, e);
 	    } else {
 		debug_trap("storeUfsDirRebuildFromSwapLog: bad condition");
 		debug(20, 1) ("\tSee %s:%d\n", __FILE__, __LINE__);
@@ -640,14 +634,14 @@
 	} else if (e) {
 	    /* key already exists, this swapfile not being used */
 	    /* junk old, load new */
-            storeExpireNow(e);
-            storeReleaseRequest(e);
-            storeUfsDirReplRemove(e);
+	    storeExpireNow(e);
+	    storeReleaseRequest(e);
+	    storeUfsDirReplRemove(e);
 	    if (e->swap_filen > -1) {
-                /* Make sure we don't actually unlink the file */
+		/* Make sure we don't actually unlink the file */
 		storeUfsDirMapBitReset(SD, e->swap_filen);
 		e->swap_filen = -1;
-                e->swap_dirn = -1;
+		e->swap_dirn = -1;
 	    }
 	    storeRelease(e);
 	    rb->counts.dupcount++;
@@ -677,15 +671,14 @@
 storeUfsDirGetNextFile(RebuildState * rb, int *sfileno, int *size)
 {
     SwapDir *SD = rb->sd;
-    ufsinfo_t *ufsinfo = (ufsinfo_t *)SD->fsdata;
+    ufsinfo_t *ufsinfo = (ufsinfo_t *) SD->fsdata;
     int fd = -1;
     int used = 0;
     int dirs_opened = 0;
     debug(20, 3) ("storeUfsDirGetNextFile: flag=%d, %d: /%02X/%02X\n",
 	rb->flags.init,
 	rb->sd->index,
-	rb->curlvl1,
-	rb->curlvl2);
+	rb->curlvl1, rb->curlvl2);
     if (rb->done)
 	return -2;
     while (fd < 0 && rb->done == 0) {
@@ -701,7 +694,8 @@
 	if (0 == rb->in_dir) {	/* we need to read in a new directory */
 	    snprintf(rb->fullpath, SQUID_MAXPATHLEN, "%s/%02X/%02X",
 		rb->sd->path,
-		rb->curlvl1, rb->curlvl2);
+		rb->curlvl1,
+		rb->curlvl2);
 	    if (rb->flags.init && rb->td != NULL)
 		closedir(rb->td);
 	    rb->td = NULL;
@@ -763,7 +757,7 @@
 /* Add a new object to the cache with empty memory copy and pointer to disk
  * use to rebuild store from disk. */
 static StoreEntry *
-storeUfsDirAddDiskRestore(SwapDir *SD, const cache_key * key,
+storeUfsDirAddDiskRestore(SwapDir * SD, const cache_key * key,
     int file_number,
     size_t swap_file_sz,
     time_t expires,
@@ -786,9 +780,6 @@
     e->swap_dirn = SD->index;
     e->swap_file_sz = swap_file_sz;
     e->lock_count = 0;
-#if !HEAP_REPLACEMENT
-    e->refcount = 0;
-#endif
     e->lastref = lastref;
     e->timestamp = timestamp;
     e->expires = expires;
@@ -844,7 +835,7 @@
 static void
 storeUfsDirCloseTmpSwapLog(SwapDir * sd)
 {
-    ufsinfo_t *ufsinfo = (ufsinfo_t *)sd->fsdata;
+    ufsinfo_t *ufsinfo = (ufsinfo_t *) sd->fsdata;
     char *swaplog_path = xstrdup(storeUfsDirSwapLogFile(sd, NULL));
     char *new_path = xstrdup(storeUfsDirSwapLogFile(sd, ".new"));
     int fd;
@@ -872,7 +863,7 @@
 static FILE *
 storeUfsDirOpenTmpSwapLog(SwapDir * sd, int *clean_flag, int *zero_flag)
 {
-    ufsinfo_t *ufsinfo = (ufsinfo_t *)sd->fsdata;
+    ufsinfo_t *ufsinfo = (ufsinfo_t *) sd->fsdata;
     char *swaplog_path = xstrdup(storeUfsDirSwapLogFile(sd, NULL));
     char *clean_path = xstrdup(storeUfsDirSwapLogFile(sd, ".last-clean"));
     char *new_path = xstrdup(storeUfsDirSwapLogFile(sd, ".new"));
@@ -925,6 +916,7 @@
     char *outbuf;
     off_t outbuf_offset;
     int fd;
+    RemovalPolicyWalker *walker;
 };
 
 #define CLEAN_BUF_SZ 16384
@@ -934,7 +926,7 @@
  * we succeed, and assign the 'func' and 'data' return pointers.
  */
 static int
-storeUfsDirWriteCleanOpen(SwapDir * sd)
+storeUfsDirWriteCleanStart(SwapDir * sd)
 {
     struct _clean_state *state = xcalloc(1, sizeof(*state));
     struct stat sb;
@@ -945,6 +937,7 @@
     state->cln = xstrdup(storeUfsDirSwapLogFile(sd, ".last-clean"));
     state->outbuf = xcalloc(CLEAN_BUF_SZ, 1);
     state->outbuf_offset = 0;
+    state->walker = sd->repl->WalkInit(sd->repl);
     unlink(state->new);
     unlink(state->cln);
     state->fd = file_open(state->new, O_WRONLY | O_CREAT | O_TRUNC);
@@ -962,18 +955,27 @@
 }
 
 /*
+ * Get the next entry that is a candidate for clean log writing
+ */
+const StoreEntry *
+storeUfsDirCleanLogNextEntry(SwapDir * sd)
+{
+    const StoreEntry *entry = NULL;
+    struct _clean_state *state = sd->log.clean.state;
+    if (state->walker)
+	entry = state->walker->Next(state->walker);
+    return entry;
+}
+
+/*
  * "write" an entry to the clean log file.
  */
 static void
-storeUfsDirWriteCleanEntry(const StoreEntry * e, SwapDir * sd)
+storeUfsDirWriteCleanEntry(SwapDir * sd, const StoreEntry * e)
 {
     storeSwapLogData s;
     static size_t ss = sizeof(storeSwapLogData);
     struct _clean_state *state = sd->log.clean.state;
-    if (NULL == e) {
-	storeUfsDirWriteCleanClose(sd);
-	return;
-    }
     memset(&s, '\0', ss);
     s.op = (char) SWAP_LOG_ADD;
     s.swap_filen = e->swap_filen;
@@ -1005,11 +1007,12 @@
 }
 
 static void
-storeUfsDirWriteCleanClose(SwapDir * sd)
+storeUfsDirWriteCleanDone(SwapDir * sd)
 {
     struct _clean_state *state = sd->log.clean.state;
     if (state->fd < 0)
 	return;
+    state->walker->Done(state->walker);
     if (write(state->fd, state->outbuf, state->outbuf_offset) < 0) {
 	debug(50, 0) ("storeDirWriteCleanLogs: %s: write: %s\n",
 	    state->new, xstrerror());
@@ -1058,7 +1061,7 @@
 static void
 storeUfsDirSwapLog(const SwapDir * sd, const StoreEntry * e, int op)
 {
-    ufsinfo_t *ufsinfo = (ufsinfo_t *)sd->fsdata;
+    ufsinfo_t *ufsinfo = (ufsinfo_t *) sd->fsdata;
     storeSwapLogData *s = xcalloc(1, sizeof(storeSwapLogData));
     s->op = (char) op;
     s->swap_filen = e->swap_filen;
@@ -1117,7 +1120,7 @@
     N0 = n_ufs_dirs;
     D0 = ufs_dir_index[swap_index % N0];
     SD = &Config.cacheSwap.swapDirs[D0];
-    ufsinfo = (ufsinfo_t *)SD->fsdata;
+    ufsinfo = (ufsinfo_t *) SD->fsdata;
     N1 = ufsinfo->l1;
     D1 = (swap_index / N0) % N1;
     N2 = ufsinfo->l2;
@@ -1139,7 +1142,7 @@
     while ((de = readdir(dp)) != NULL && k < 20) {
 	if (sscanf(de->d_name, "%X", &swapfileno) != 1)
 	    continue;
-	fn = swapfileno; /* XXX should remove this cruft ! */
+	fn = swapfileno;	/* XXX should remove this cruft ! */
 	if (storeUfsDirValidFileno(SD, fn))
 	    if (storeUfsDirMapBitTest(SD, fn))
 		if (storeUfsFilenoBelongsHere(fn, D0, D1, D2))
@@ -1185,7 +1188,7 @@
     assert(n_ufs_dirs);
     if (NULL == ufs_dir_index) {
 	SwapDir *sd;
-        ufsinfo_t *ufsinfo;
+	ufsinfo_t *ufsinfo;
 	/*
 	 * Initialize the little array that translates UFS cache_dir
 	 * number into the Config.cacheSwap.swapDirs array index.
@@ -1196,7 +1199,7 @@
 	    if (!storeUfsDirIs(sd))
 		continue;
 	    ufs_dir_index[n++] = i;
-            ufsinfo = (ufsinfo_t *)sd->fsdata;
+	    ufsinfo = (ufsinfo_t *) sd->fsdata;
 	    j += (ufsinfo->l1 * ufsinfo->l2);
 	}
 	assert(n == n_ufs_dirs);
@@ -1235,7 +1238,7 @@
     int filn = fn;
     ufsinfo_t *ufsinfo;
     assert(F0 < Config.cacheSwap.n_configured);
-    ufsinfo = (ufsinfo_t *)Config.cacheSwap.swapDirs[F0].fsdata;
+    ufsinfo = (ufsinfo_t *) Config.cacheSwap.swapDirs[F0].fsdata;
     L1 = ufsinfo->l1;
     L2 = ufsinfo->l2;
     D1 = ((filn / L2) / L2) % L1;
@@ -1247,167 +1250,60 @@
     return 1;
 }
 
-int 
-storeUfsDirValidFileno(SwapDir *SD, sfileno filn)
+int
+storeUfsDirValidFileno(SwapDir * SD, sfileno filn)
 {
-    ufsinfo_t *ufsinfo = (ufsinfo_t *)SD->fsdata;
+    ufsinfo_t *ufsinfo = (ufsinfo_t *) SD->fsdata;
     if (filn < 0)
-        return 0;
-    if (filn > ufsinfo->map->max_n_files)  
-        return 0;
+	return 0;
+    if (filn > ufsinfo->map->max_n_files)
+	return 0;
     return 1;
 }
 
 void
-storeUfsDirMaintain(SwapDir *SD)
+storeUfsDirMaintain(SwapDir * SD)
 {
     StoreEntry *e = NULL;
-    int scanned = 0;
-    int locked = 0;
-    int expired = 0;
+    int removed = 0;
     int max_scan;
     int max_remove;
     double f;
-    static time_t last_warn_time = 0;
-#if !HEAP_REPLACEMENT
-    dlink_node *m;
-    dlink_node *prev = NULL;
-#else
-    heap_key age;
-    heap_key min_age = 0.0;
-    link_list *locked_entries = NULL;
-#if HEAP_REPLACEMENT_DEBUG
-    if (!verify_heap_property(SD->repl.heap.heap)) {
-        debug(20, 1) ("Heap property violated!\n");
-    }
-#endif
-#endif
+    RemovalPurgeWalker *walker;
     /* We can't delete objects while rebuilding swap */
     if (store_dirs_rebuilding) {
-        return;
+	return;
     } else {
-        f = (double) (store_swap_size - store_swap_low) / (store_swap_high - store_swap_low);
-        f = f < 0.0 ? 0.0 : f > 1.0 ? 1.0 : f;
-        max_scan = (int) (f * 400.0 + 100.0);
-        max_remove = (int) (f * 70.0 + 10.0);
+	/* XXX FixMe: This should use the cache_dir hig/low values, not the
+	 * global ones
+	 */
+	f = (double) (store_swap_size - store_swap_low) / (store_swap_high - store_swap_low);
+	f = f < 0.0 ? 0.0 : f > 1.0 ? 1.0 : f;
+	max_scan = (int) (f * 400.0 + 100.0);
+	max_remove = (int) (f * 70.0 + 10.0);
 	/*
 	 * This is kinda cheap, but so we need this priority hack?
-         */
-#if 0
-        eventAdd("MaintainSwapSpace", storeMaintainSwapSpace, NULL, 1.0 - f, 1);
-#endif
+	 */
     }
     debug(20, 3) ("storeMaintainSwapSpace: f=%f, max_scan=%d, max_remove=%d\n", f, max_scan, max_remove);
-#if HEAP_REPLACEMENT
-    while (heap_nodes(SD->repl.heap.heap) > 0) {
-        if (store_swap_size < store_swap_low)
-            break;
-        if (expired >= max_remove)
-            break;
-        if (scanned >= max_scan)
-            break;
-        age = heap_peepminkey(SD->repl.heap.heap);
-        e = heap_extractmin(SD->repl.heap.heap);
-        e->repl.node = NULL;         /* no longer in the heap */
-        scanned++;
-        if (storeEntryLocked(e)) {
-            /*
-             * Entry is in use ... put it in a linked list to ignore it.
-             */
-            if (!EBIT_TEST(e->flags, ENTRY_SPECIAL)) {
-                /*
-                 * If this was a "SPECIAL" do not add it back into the heap.
-                 * It will always be "SPECIAL" and therefore never removed.
-                 */
-                debug(20, 4) ("storeUfsDirMaintain: locked url %s\n",
-                    (e->mem_obj && e->mem_obj->url) ? e->mem_obj->url : storeKeyText(e->
-key));
-                linklistPush(&locked_entries, e);
-            }
-            locked++;
-            continue;
-        } else if (storeUfsDirCheckExpired(SD, e)) {
-            /*
-             * Note: This will not check the reference age ifdef
-             * HEAP_REPLACEMENT, but it does some other useful
-             * checks...
-             */
-            expired++;
-            debug(20, 3) ("Released store object age %f size %d refs %d key %s\n",
-                age, e->swap_file_sz, e->refcount, storeKeyText(e->key));
-            min_age = age;
-            storeRelease(e);
-        } else {
-            /*
-             * Did not expire the object so we need to add it back
-             * into the heap!
-             */
-            debug(20, 5) ("storeMaintainSwapSpace: non-expired %s\n",
-                storeKeyText(e->key));
-            linklistPush(&locked_entries, e);
-            continue;
-        }
-        if (store_swap_size < store_swap_low)
-            break;
-        else if (expired >= max_remove)
-            break;
-        else if (scanned >= max_scan)
-            break;
-    }
-    /*
-     * Bump the heap age factor.
-     */
-    if (min_age > 0.0)
-        SD->repl.heap.heap->age = min_age;
-    /*
-     * Reinsert all bumped locked entries back into heap...
-     */
-    while ((e = linklistShift(&locked_entries)))
-        e->repl.node = heap_insert(SD->repl.heap.heap, e);
-#else
-    for (m = SD->repl.lru.list.tail; m; m = prev) {
-        prev = m->prev;
-        e = m->data;
-        scanned++;
-        if (storeEntryLocked(e)) {
-            /*
-             * If there is a locked entry at the tail of the LRU list,
-             * move it to the beginning to get it out of the way.
-             * Theoretically, we might have all locked objects at the
-             * tail, and then we'll never remove anything here and the
-             * LRU age will go to zero.
-             */
-            if (memInUse(MEM_STOREENTRY) > max_scan) {
-                dlinkDelete(&e->repl.lru, &SD->repl.lru.list);
-                dlinkAdd(e, &e->repl.lru, &SD->repl.lru.list);
-            }
-            locked++;
-
-        } else if (storeUfsDirCheckExpired(SD, e)) {
-            expired++;
-            storeRelease(e);
-        }
-        if (expired >= max_remove)
-            break;
-        if (scanned >= max_scan)
-            break;
-    }
-#endif
-    debug(20, (expired ? 2 : 3)) ("storeMaintainSwapSpace: scanned %d/%d removed %d/%d l
-ocked %d f=%.03f\n",
-        scanned, max_scan, expired, max_remove, locked, f);
-    debug(20, 3) ("storeMaintainSwapSpace stats:\n");
-    debug(20, 3) ("  %6d objects\n", memInUse(MEM_STOREENTRY));
-    debug(20, 3) ("  %6d were scanned\n", scanned);
-    debug(20, 3) ("  %6d were locked\n", locked);
-    debug(20, 3) ("  %6d were expired\n", expired);
-    if (store_swap_size < Config.Swap.maxSize)
-        return;
-    if (squid_curtime - last_warn_time < 10)
-        return;
-    debug(20, 0) ("WARNING: Disk space over limit: %d KB > %d KB\n",
-        store_swap_size, Config.Swap.maxSize);
-    last_warn_time = squid_curtime;
+    walker = SD->repl->PurgeInit(SD->repl, max_scan);
+    while (1) {
+	/* XXX FixMe: This should use the cache_dir hig/low values, not the
+	 * global ones
+	 */
+	if (store_swap_size < store_swap_low)
+	    break;
+	if (removed >= max_remove)
+	    break;
+	e = walker->Next(walker);
+	if (!e)
+	    break;		/* no more objects */
+	removed++;
+	storeRelease(e);
+    }
+    walker->Done(walker);
+    debug(20, (removed ? 2 : 3)) ("storeUfsDirMaintain: %s removed %d/%d f=%.03f max_scan=%d\n",
+	SD->path, removed, max_remove, f, max_scan);
 }
 
 /*
@@ -1418,14 +1314,14 @@
  * happily store anything as long as the LRU time isn't too small.
  */
 int
-storeUfsDirCheckObj(SwapDir *SD, const StoreEntry *e)
+storeUfsDirCheckObj(SwapDir * SD, const StoreEntry * e)
 {
-#if !HEAP_REPLACEMENT
+#if OLD_UNUSED_CODE
     if (storeUfsDirExpiredReferenceAge(SD) < 300) {
-        debug(20, 3) ("storeUfsDirCheckObj: NO: LRU Age = %d\n",
-            storeUfsDirExpiredReferenceAge(SD));
-        /* store_check_cachable_hist.no.lru_age_too_low++; */
-        return -1;
+	debug(20, 3) ("storeUfsDirCheckObj: NO: LRU Age = %d\n",
+	    storeUfsDirExpiredReferenceAge(SD));
+	/* store_check_cachable_hist.no.lru_age_too_low++; */
+	return -1;
     }
 #endif
     /* Return 999 (99.9%) constant load */
@@ -1439,20 +1335,12 @@
  * maintain replacement information within the storage fs.
  */
 void
-storeUfsDirRefObj(SwapDir *SD, StoreEntry *e)
+storeUfsDirRefObj(SwapDir * SD, StoreEntry * e)
 {
     debug(1, 3) ("storeUfsDirRefObj: referencing %p %d/%d\n", e, e->swap_dirn,
-      e->swap_filen);
-#if HEAP_REPLACEMENT
-    /* Nothing to do here */
-#else
-    /* Reference the object */
-    if (!EBIT_TEST(e->flags, RELEASE_REQUEST) &&
-        !EBIT_TEST(e->flags, ENTRY_SPECIAL)) {
-        dlinkDelete(&e->repl.lru, &SD->repl.lru.list);
-        dlinkAdd(e, &e->repl.lru, &SD->repl.lru.list);
-    }
-#endif
+	e->swap_filen);
+    if (SD->repl->Referenced)
+	SD->repl->Referenced(SD->repl, e, &e->repl);
 }
 
 /*
@@ -1461,14 +1349,12 @@
  * removed, to maintain replacement information within the storage fs.
  */
 void
-storeUfsDirUnrefObj(SwapDir *SD, StoreEntry *e)
+storeUfsDirUnrefObj(SwapDir * SD, StoreEntry * e)
 {
     debug(1, 3) ("storeUfsDirUnrefObj: referencing %p %d/%d\n", e, e->swap_dirn,
-      e->swap_filen);
-#if HEAP_REPLACEMENT
-    if (e->repl.node)
-        heap_update(SD->repl.heap.heap, e->repl.node, e);
-#endif
+	e->swap_filen);
+    if (SD->repl->Dereferenced)
+	SD->repl->Dereferenced(SD->repl, e, &e->repl);
 }
 
 /*
@@ -1479,124 +1365,34 @@
  * forced this bit of code here. Eeek.
  */
 void
-storeUfsDirUnlinkFile(SwapDir *SD, sfileno f)
+storeUfsDirUnlinkFile(SwapDir * SD, sfileno f)
 {
     debug(79, 3) ("storeUfsDirUnlinkFile: unlinking fileno %08X\n", f);
     storeUfsDirMapBitReset(SD, f);
     unlinkdUnlink(storeUfsDirFullPath(SD, f, NULL));
 }
 
-#if !HEAP_REPLACEMENT
-/*
- * storeUfsDirExpiredReferenceAge
- *
- * The LRU age is scaled exponentially between 1 minute and
- * Config.referenceAge , when store_swap_low < store_swap_size <
- * store_swap_high.  This keeps store_swap_size within the low and high
- * water marks.  If the cache is very busy then store_swap_size stays
- * closer to the low water mark, if it is not busy, then it will stay
- * near the high water mark.  The LRU age value can be examined on the
- * cachemgr 'info' page.
- */
-static time_t
-storeUfsDirExpiredReferenceAge(SwapDir *SD)
-{
-    double x;
-    double z;
-    time_t age;
-    long store_high, store_low;
- 
-    store_high = (long) (((float) SD->max_size *
-            (float) Config.Swap.highWaterMark) / (float) 100);
-    store_low = (long) (((float) SD->max_size *
-            (float) Config.Swap.lowWaterMark) / (float) 100);
-    debug(20, 20) ("RA: Dir %s, hi=%d, lo=%d, cur=%d\n", SD->path, store_high, store_low, SD->cur_size);
-  
-    x = (double) (store_high - SD->cur_size) /
-        (store_high - store_low);
-    x = x < 0.0 ? 0.0 : x > 1.0 ? 1.0 : x;
-    z = pow((double) (Config.referenceAge / 60), x);
-    age = (time_t) (z * 60.0);
-    if (age < 60)
-        age = 60;
-    else if (age > Config.referenceAge)
-        age = Config.referenceAge;
-    return age;
-}
-#endif
-
-/*
- * storeUfsDirCheckExpired
- *
- * Check whether the given object is expired or not
- * It breaks layering a little by calling the upper layers to find
- * out whether the object is locked or not, but we can't help this
- * right now.
- */
-static int
-storeUfsDirCheckExpired(SwapDir *SD, StoreEntry *e)
-{
-    if (storeEntryLocked(e))
-       return 0;
-    if (EBIT_TEST(e->flags, RELEASE_REQUEST))
-       return 1;
-    if (EBIT_TEST(e->flags, ENTRY_NEGCACHED) && squid_curtime >= e->expires)
-       return 1;
-
-#if HEAP_REPLACEMENT
-    /*
-     * with HEAP_REPLACEMENT we are not using the LRU reference age, the heap
-     * controls the replacement of objects.
-     */
-    return 1;
-#else
-    if (squid_curtime - e->lastref > storeUfsDirExpiredReferenceAge(SD))
-       return 1;
-    return 0;
-#endif
-}
-
 /*
  * Add and remove the given StoreEntry from the replacement policy in
  * use.
  */
 
 void
-storeUfsDirReplAdd(SwapDir *SD, StoreEntry *e)
+storeUfsDirReplAdd(SwapDir * SD, StoreEntry * e)
 {
     debug(20, 4) ("storeUfsDirReplAdd: added node %p to dir %d\n", e,
-      SD->index);
-#if HEAP_REPLACEMENT
-    if (EBIT_TEST(e->flags, ENTRY_SPECIAL)) {
-        (void) 0;
-    } else {
-        e->repl.node = heap_insert(SD->repl.heap.heap, e);
-        debug(20, 4) ("storeUfsDirReplAdd: inserted node 0x%x\n", e->repl.node);
-    }
-#else
-    /* Shouldn't we not throw special objects into the lru ? */
-    dlinkAdd(e, &e->repl.lru, &SD->repl.lru.list);
-#endif
+	SD->index);
+    SD->repl->Add(SD->repl, e, &e->repl);
 }
 
 
 void
-storeUfsDirReplRemove(StoreEntry *e)
+storeUfsDirReplRemove(StoreEntry * e)
 {
     SwapDir *SD = INDEXSD(e->swap_dirn);
     debug(20, 4) ("storeUfsDirReplRemove: remove node %p from dir %d\n", e,
-      SD->index);
-#if HEAP_REPLACEMENT
-    /* And now, release the object from the replacement policy */
-    if (e->repl.node) {
-        debug(20, 4) ("storeUfsDirReplRemove: deleting node 0x%x\n",
-          e->repl.node);
-        heap_delete(SD->repl.heap.heap, e->repl.node);
-        e->repl.node = NULL;
-    }
-#else
-    dlinkDelete(&e->repl.lru, &SD->repl.lru.list);
-#endif
+	SD->index);
+    SD->repl->Remove(SD->repl, e, &e->repl);
 }
 
 
@@ -1604,51 +1400,51 @@
 /* ========== LOCAL FUNCTIONS ABOVE, GLOBAL FUNCTIONS BELOW ========== */
 
 void
-storeUfsDirStats(SwapDir *SD, StoreEntry * sentry)
+storeUfsDirStats(SwapDir * SD, StoreEntry * sentry)
 {
     ufsinfo_t *ufsinfo;
 #if HAVE_STATVFS
     struct statvfs sfs;
 #endif
-    ufsinfo = (ufsinfo_t *)SD->fsdata;
+    ufsinfo = (ufsinfo_t *) SD->fsdata;
     storeAppendPrintf(sentry, "First level subdirectories: %d\n", ufsinfo->l1);
     storeAppendPrintf(sentry, "Second level subdirectories: %d\n", ufsinfo->l2);
     storeAppendPrintf(sentry, "Maximum Size: %d KB\n", SD->max_size);
     storeAppendPrintf(sentry, "Current Size: %d KB\n", SD->cur_size);
     storeAppendPrintf(sentry, "Percent Used: %0.2f%%\n",
-        100.0 * SD->cur_size / SD->max_size);
+	100.0 * SD->cur_size / SD->max_size);
     storeAppendPrintf(sentry, "Filemap bits in use: %d of %d (%d%%)\n",
-    ufsinfo->map->n_files_in_map, ufsinfo->map->max_n_files,
-    percent(ufsinfo->map->n_files_in_map, ufsinfo->map->max_n_files));
+	ufsinfo->map->n_files_in_map, ufsinfo->map->max_n_files,
+	percent(ufsinfo->map->n_files_in_map, ufsinfo->map->max_n_files));
 #if HAVE_STATVFS
 #define fsbtoblk(num, fsbs, bs) \
     (((fsbs) != 0 && (fsbs) < (bs)) ? \
             (num) / ((bs) / (fsbs)) : (num) * ((fsbs) / (bs)))
-	if (!statvfs(SD->path, &sfs)) {
-            storeAppendPrintf(sentry, "Filesystem Space in use: %d/%d KB (%d%%)\n",
-            fsbtoblk((sfs.f_blocks - sfs.f_bfree), sfs.f_frsize, 1024),
-            fsbtoblk(sfs.f_blocks, sfs.f_frsize, 1024),
-            percent(sfs.f_blocks - sfs.f_bfree, sfs.f_blocks));
-            storeAppendPrintf(sentry, "Filesystem Inodes in use: %d/%d (%d%%)\n",
-            sfs.f_files - sfs.f_ffree, sfs.f_files,
-            percent(sfs.f_files - sfs.f_ffree, sfs.f_files));
+    if (!statvfs(SD->path, &sfs)) {
+	storeAppendPrintf(sentry, "Filesystem Space in use: %d/%d KB (%d%%)\n",
+	    fsbtoblk((sfs.f_blocks - sfs.f_bfree), sfs.f_frsize, 1024),
+	    fsbtoblk(sfs.f_blocks, sfs.f_frsize, 1024),
+	    percent(sfs.f_blocks - sfs.f_bfree, sfs.f_blocks));
+	storeAppendPrintf(sentry, "Filesystem Inodes in use: %d/%d (%d%%)\n",
+	    sfs.f_files - sfs.f_ffree, sfs.f_files,
+	    percent(sfs.f_files - sfs.f_ffree, sfs.f_files));
     }
 #endif
     storeAppendPrintf(sentry, "Flags:");
     if (SD->flags.selected)
-        storeAppendPrintf(sentry, " SELECTED");
+	storeAppendPrintf(sentry, " SELECTED");
     if (SD->flags.read_only)
-        storeAppendPrintf(sentry, " READ-ONLY");
+	storeAppendPrintf(sentry, " READ-ONLY");
     storeAppendPrintf(sentry, "\n");
+#if OLD_UNUSED_CODE
 #if !HEAP_REPLACEMENT
     storeAppendPrintf(sentry, "LRU Expiration Age: %6.2f days\n",
-      (double) storeUfsDirExpiredReferenceAge(SD) / 86400.0); 
+	(double) storeUfsDirExpiredReferenceAge(SD) / 86400.0);
 #else
-#if 0
     storeAppendPrintf(sentry, "Storage Replacement Threshold:\t%f\n",
-        heap_peepminkey(sd.repl.heap.heap));
-#endif
+	heap_peepminkey(sd.repl.heap.heap));
 #endif
+#endif /* OLD_UNUSED_CODE */
 }
 
 /*
@@ -1657,7 +1453,7 @@
  * This routine is called when the given swapdir needs reconfiguring 
  */
 void
-storeUfsDirReconfigure(SwapDir *sd, int index, char *path)
+storeUfsDirReconfigure(SwapDir * sd, int index, char *path)
 {
     char *token;
     int i;
@@ -1700,10 +1496,10 @@
 void
 storeUfsDirDump(StoreEntry * entry, const char *name, SwapDir * s)
 {
-    ufsinfo_t *ufsinfo = (ufsinfo_t *)s->fsdata;
+    ufsinfo_t *ufsinfo = (ufsinfo_t *) s->fsdata;
     storeAppendPrintf(entry, "%s %s %s %d %d %d\n",
 	name,
-        "ufs",
+	"ufs",
 	s->path,
 	s->max_size >> 10,
 	ufsinfo->l1,
